/*
 * Created on 2004-11-29
 */
import java.io.IOException;

import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**
 * @author Patryk Czarnik
 */
public class LiczbySAX {
  public static void main(String[] args) {
    if(args.length < 1) {
      System.out.println("Za malo parametrow");
      return;
    }

    try {
      SAXParserFactory factory = SAXParserFactory.newInstance();
      factory.setValidating(true);
      SAXParser parser = factory.newSAXParser();
      
      MyHandler handler = new MyHandler();
      parser.parse(args[0], handler);

      System.out.println("Result: "+handler.getResult());
    } catch (FactoryConfigurationError e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    } catch (SAXException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    } catch (ParserConfigurationException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    } catch (IOException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
  }
  
  private static class MyHandler extends DefaultHandler {
    private static int cState_Out = 0;
    private static int cState_Group = 1;
    private static int cState_L = 2;

    private int fResult = 0;
    private int fState = cState_Out;
    private StringBuffer fBuf;
    
    public int getResult() {
      return fResult;
    }
   
    public void startElement(String uri, String localName, String qName,
        Attributes attributes) throws SAXException {
      if(qName.equals("grupa")) {
        String attrVal = attributes.getValue("wazne");
        if(attrVal.equals("tak"))
          fState = cState_Group;
      } else if(qName.equals("l")) {
        if(fState == cState_Group) {
          fState = cState_L;
          fBuf = new StringBuffer();
        }
      }
    }

    public void endElement(String uri, String localName, String qName)
    throws SAXException {
      if(qName.equals("grupa")) {
        if(fState == cState_Group) {
          fState = cState_Out;
        }
      } else if(qName.equals("l")) {
        if(fState == cState_L) {
          fState = cState_Group;
          try {
            fResult += Integer.parseInt(fBuf.toString());
          } catch (NumberFormatException e) {
          }
        }
      }
    }
    public void characters(char[] ch, int start, int length)
        throws SAXException {
      if(fState == cState_L)
        fBuf.append(ch, start, length);
    }
  }
}
